using System.Security.Cryptography;
using IdentityModel;
using IdentityModel.Jwk;


namespace FitConnect.Encryption;

public static class JsonWebKeyExtension {
    public static RSA ToRsaKey(this JsonWebKey jsonWebKey) {
        var rsa = RSA.Create();
        rsa.ImportParameters(new RSAParameters {
            Modulus = Base64Url.Decode(jsonWebKey.N),
            Exponent = Base64Url.Decode(jsonWebKey.E),
            D = Base64Url.Decode(jsonWebKey.D),
            P = Base64Url.Decode(jsonWebKey.P),
            Q = Base64Url.Decode(jsonWebKey.Q),
            DP = Base64Url.Decode(jsonWebKey.DP),
            DQ = Base64Url.Decode(jsonWebKey.DQ),
            InverseQ = Base64Url.Decode(jsonWebKey.QI),
        });
        //  = "RSA-OAEP-256";
        return rsa;
    } 
}
